Index: main/cli.c
===================================================================
--- main/cli.c	(revision 96621)
+++ main/cli.c	(working copy)
@@ -119,25 +119,6 @@
 
 static AST_RWLIST_HEAD_STATIC(helpers, ast_cli_entry);
 
-static char *complete_fn(const char *word, int state)
-{
-	char *c;
-	char filename[256];
-
-	if (word[0] == '/')
-		ast_copy_string(filename, word, sizeof(filename));
-	else
-		snprintf(filename, sizeof(filename), "%s/%s", ast_config_AST_MODULE_DIR, word);
-
-	/* XXX the following function is not reentrant, so we better not use it */
-	c = filename_completion_function(filename, state);
-	
-	if (c && word[0] != '/')
-		c += (strlen(ast_config_AST_MODULE_DIR) + 1);
-	
-	return c ? ast_strdup(c) : c;
-}
-
 static char *handle_load(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
 {
 	/* "module load <mod>" */
@@ -150,9 +131,7 @@
 		return NULL;
 
 	case CLI_GENERATE:
-		if (a->pos != e->args)
-			return NULL;
-		return complete_fn(a->word, a->n);
+		return ast_module_helper(a->line, a->word, a->pos, a->n, a->pos, 0);
 	}
 	if (a->argc != e->args + 1)
 		return CLI_SHOWUSAGE;
